import gmsh
from numpy import pi, arcsin, cos

from qosm.items.Mesh import Mesh
from qosm.utils.Pose import Frame, Vector
from qosm.sources import Source


class MshMesh(Mesh):
    def __init__(self, f_obj_ref: Frame = Frame(), source: Source = None):
        super().__init__(f_obj_ref)

    def load_mesh(self, element_size: float, scale: float = 1., view=False, show_vectors=True):
        gmsh.option.setNumber("Geometry.Tolerance", 1e-8)
        gmsh.option.setNumber("Mesh.Algorithm", 6)
        gmsh.option.setNumber('Mesh.MeshSizeMin', element_size)
        gmsh.option.setNumber('Mesh.MeshSizeMax', element_size)

        gmsh.model.occ.removeAllDuplicates()
        gmsh.model.occ.synchronize()
        gmsh.model.mesh.generate(2)

        gmsh.model.mesh.removeDuplicateNodes()

        self.pre_build(scale, False, None, view, show_vectors, Vector(), False)
